package net.sf.sido.constraint;

import java.math.BigDecimal;

import com.google.common.base.Predicate;

public class LTConstraint<N extends Number> implements Predicate<N> {

	private final BigDecimal max;

	public LTConstraint(BigDecimal max) {
		this.max = max;
	}

	@Override
	public boolean apply(N n) {
		return new BigDecimal(n.toString()).compareTo(this.max) < 0;
	}

}
