package net.sf.sido.factory.support;

import com.google.common.base.Predicate;
import net.sf.sido.DataFactory;
import net.sf.sido.DataObject;
import net.sf.sido.DataSchema;
import net.sf.sido.DataType;
import net.sf.sido.array.IndexedArray;

import java.io.IOException;
import java.util.Map;

public class IndexedArrayDOPropertyAssembler extends AbstractPropertyAssembler {

    private final String type;
    private final String arrayIndexProperty;

    public IndexedArrayDOPropertyAssembler(String name, String type, String arrayIndexProperty) {
        super(name);
        this.type = type;
        this.arrayIndexProperty = arrayIndexProperty;
    }

    @Override
    public <T> void addProperty(DataFactory factory, PropertyAssemblerCallback callback, Map<String, DataSchema> schemas, Map<String, TypeDefinition> typeDefinitions, TypeDefinition definition, DataObject property) throws IOException {
        // Element type
        DataType elementType = callback.getDOType(factory, schemas, typeDefinitions, definition.getQualifiedName(type));
        // Nullable
        boolean nullable = isNullable(property);
        // Constraint
        Predicate<IndexedArray<DataObject, Object>> constraint = readConstraint(factory, property);
        // Adds the property
        definition.getBuilder().addIndexedArrayProperty(name, elementType, arrayIndexProperty, nullable, constraint);
    }
}
