package net.sf.sido.support;

import java.math.BigDecimal;

import net.sf.sido.PropertyAdapter;

public class DecimalPropertyAdapter implements PropertyAdapter<BigDecimal> {

	@Override
	public boolean canConvert(Object o) {
		return (o instanceof Number);
	}

	@Override
	public BigDecimal convert(Object o) {
		if (o instanceof BigDecimal) {
			return (BigDecimal) o;
		} else if (o instanceof Float || o instanceof Double) {
			return BigDecimal.valueOf(((Number) o).doubleValue());
		} else {
			return BigDecimal.valueOf(((Number) o).longValue());
		}
	}

}
